%bcond_without perl_PDF_Builder_enables_html
%bcond_without perl_PDF_Builder_enables_markdown
%bcond_without perl_PDF_Builder_enables_optional_test
%bcond_without perl_PDF_Builder_enables_png
%bcond_without perl_PDF_Builder_enables_tiff

Name:           perl-PDF-Builder
Version:        3.025
Release:    1%{?dist}
Summary:        Creation and modification of PDF files in Perl
License:        LGPL-2.1-or-later AND LGPL-2.1-only AND MIT
URL:            https://metacpan.org/release/PDF-Builder
Source0:        https://cpan.metacpan.org/authors/id/P/PM/PMPERRY/PDF-Builder-%{version}.tar.gz
Patch0:         PDF-Builder-3.024-Don-t-skip-ghostscript-9.56.-0-1.patch
Patch1:         PDF-Builder-3.024-Search-URW-fonts-in-usr-share-GraphicsMagick.patch
BuildArch:      noarch
BuildRequires:  coreutils
BuildRequires:  make
BuildRequires:  perl-generators
BuildRequires:  perl-interpreter
BuildRequires:  perl(:VERSION) >= 5.24
BuildRequires:  perl(ExtUtils::MakeMaker) >= 6.76
BuildRequires:  perl(strict)
BuildRequires:  perl(warnings)
BuildRequires:  perl(base)
BuildRequires:  perl(Carp)
BuildRequires:  perl(Compress::Zlib) >= 1
BuildRequires:  perl(constant)
BuildRequires:  perl(Data::Dumper)
BuildRequires:  perl(Encode)
BuildRequires:  perl(English)
BuildRequires:  perl(Exporter)
BuildRequires:  perl(File::Basename)
BuildRequires:  perl(File::Temp)
BuildRequires:  perl(FileHandle)
BuildRequires:  perl(Font::TTF::Font)
%if %{with perl_PDF_Builder_enables_tiff}
BuildRequires:  perl(Graphics::TIFF) >= 19
%endif
%if %{with perl_PDF_Builder_enables_html}
%endif
%if %{with perl_PDF_Builder_enables_png}
BuildRequires:  perl(Image::PNG::Const)
BuildRequires:  perl(Image::PNG::Libpng) >= 0.57
%endif
BuildRequires:  perl(IO::File)
BuildRequires:  perl(List::Util)
BuildRequires:  perl(Math::Trig)
BuildRequires:  perl(POSIX)
BuildRequires:  perl(Scalar::Util)
%if %{with perl_PDF_Builder_enables_markdown}
%endif
BuildRequires:  perl(Unicode::UCD)
BuildRequires:  perl(vars)
BuildRequires:  perl(File::Find)
BuildRequires:  perl(File::Spec)
BuildRequires:  perl(IPC::Cmd)
BuildRequires:  perl(Test::Exception)
BuildRequires:  perl(Test::Memory::Cycle) >= 1
BuildRequires:  perl(Test::More)
BuildRequires:  perl(utf8)
BuildRequires:  perl(version)
%if %{with perl_PDF_Builder_enables_optional_test}
BuildRequires:  font(dejavusans)
BuildRequires:  ghostscript >= 9.25.0
BuildRequires:  ImageMagick >= 6.9.7
BuildRequires:  libtiff-tools
BuildRequires:  perl(GD)
BuildRequires:  urw-base35-fonts-legacy
%endif
Requires:       perl(Compress::Zlib) >= 1
%if %{with perl_PDF_Builder_enables_tiff}
Recommends:     perl(Graphics::TIFF) >= 19
%endif
%if %{with perl_PDF_Builder_enables_html}
Recommends:  perl(HTML::TreeBuilder) >= 5.07
%endif
%if %{with perl_PDF_Builder_enables_png}
Recommends:     perl(Image::PNG::Const)
Recommends:     perl(Image::PNG::Libpng) >= 0.57
%endif
%if %{with perl_PDF_Builder_enables_markdown}
Recommends:     perl(Text::Markdown) >= 1.000031
%endif

%global __requires_exclude %{?__requires_exclude:%{__requires_exclude}|}^perl\\((Compress::Zlib|Test::Memory::Cycle)\\)$

%global __requires_exclude %{?__requires_exclude:%{__requires_exclude}|}^perl\\((Graphics::TIFF\\)|Image::PNG::)

%description
This Perl library enables you to create, import and modify documents in
Portagble Document Format (mostly compliant to PDF 1.4 version).

%package tests
Summary:        Tests for %{name}
License:        LGPL-2.1-or-later
Requires:       %{name} = %{version}-%{release}
Requires:       perl-Test-Harness
Requires:       perl(Test::Memory::Cycle) >= 1
%if %{with perl_PDF_Builder_enables_optional_test}
Requires:       font(dejavusans)
Requires:       ghostscript >= 9.25.0
Requires:       ImageMagick >= 6.9.7
Requires:       libtiff-tools
Requires:       perl(GD)
Requires:       urw-base35-fonts-legacy
%endif

%description tests
Tests from %{name}. Execute them
with "%{_libexecdir}/%{name}/test".

%prep
%autosetup -p1 -n PDF-Builder-%{version}
for F in \
%if !%{with perl_PDF_Builder_enables_optional_test}
    t/gd.t \
%endif
;do
    rm "$F"
    perl -i -ne 'print $_ unless m{^\Q'"$F"'\E}' MANIFEST
done
perl -i -pe 's/\r$//' Changes CONTRIBUTING.md INFO/Changes_2021 INFO/SPONSORS README.md
chmod +x t/*.t

%build
perl Makefile.PL INSTALLDIRS=vendor NO_PACKLIST=1 NO_PERLLOCAL=1
%{make_build}

%install
%{make_install}
%{_fixperms} %{buildroot}/*
mkdir -p %{buildroot}%{_libexecdir}/%{name}
cp -a t %{buildroot}%{_libexecdir}/%{name}
rm %{buildroot}%{_libexecdir}/%{name}/t/00-all-usable.t
cat > %{buildroot}%{_libexecdir}/%{name}/test << 'EOF'
cd %{_libexecdir}/%{name} && exec prove -I . -j "$(getconf _NPROCESSORS_ONLN)"
EOF
chmod +x %{buildroot}%{_libexecdir}/%{name}/test

%check
export HARNESS_OPTIONS=j$(perl -e 'if ($ARGV[0] =~ /.*-j([0-9][0-9]*).*/) {print $1} else {print 1}' -- '%{?_smp_mflags}')
make test

%files
%license LICENSE
%doc Changes contrib CONTRIBUTING.md examples README.md tools
%doc INFO/CONVERSION INFO/DEPRECATED INFO/Changes* INFO/KNOWN_INCOMP
%doc INFO/PATENTS INFO/RoadMap INFO/SPONSORS INFO/SUPPORT
%dir %{perl_vendorlib}/PDF
%{perl_vendorlib}/PDF/Builder*
%{_mandir}/man3/PDF::Builder*

%files tests
%{_libexecdir}/%{name}

%changelog
* Thu Jun 20 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.025-1
- initial build
